diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java b/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
new file mode 100644
index 000000000..4f7efce80
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
@@ -0,0 +1,686 @@
+package net.minecraft.client.render.font;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texturepack.TexturePackList;
+import net.minecraft.client.util.helper.Colors;
+import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.core.util.helper.ChatAllowedCharacters;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.lwjgl.opengl.GL11;
+
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Random;
+
+public class FontRendererDefault implements FontRenderer {
+    public final @NotNull Font fallbackFont;
+    public final @NotNull Font font;
+
+    protected final long @NotNull [] configStack = new long[32];
+    protected byte stackIndex = 0;
+    protected long currentConfig = 0;
+
+    protected int currentTex = -1;
+    protected final Random random;
+
+    protected final List<@NotNull String> localStringList = new ArrayList<>();
+    protected final double[] localXPosBuffer = new double[1];
+    protected final double[] localYPosBuffer = new double[1];
+    protected final long[] localConfigBuffer = new long[1];
+
+    public FontRendererDefault(@NotNull final Font font) {
+        this.fallbackFont = new FontUnicode(Minecraft.getMinecraft().textureManager);
+        this.font = font;
+        this.random = new Random();
+    }
+
+    protected void renderStringInternal(@NotNull final Tessellator tessellator, final @NotNull CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        double currX = x;
+        final double currY = y;
+
+        this.random.setSeed(System.currentTimeMillis()/50);
+
+        for (int i = 0; i < chars.length(); i++) {
+            final char c = chars.charAt(i);
+
+            if (c == '§' && i + 1 < chars.length()) {
+                final char cNext = chars.charAt(i + 1);
+                if (cNext == '<') {
+                    int offAmount = 1;
+                    int j = i + 2; // First char after <
+                    final StringBuilder colorValue = new StringBuilder();
+                    boolean ended = false;
+                    while (j < chars.length()) {
+                        offAmount++;
+                        if (chars.charAt(j) == '>'){
+                            ended = true;
+                            break;
+                        }
+                        colorValue.append(chars.charAt(j));
+                        j++;
+                    }
+
+                    if (ended){
+                        long colorInt = 0xFFFFFF;
+                        try { colorInt = decodeHexToLong(colorValue); } catch (final NumberFormatException ignored){}
+
+                        this.currentConfig = SF.setColor(this.currentConfig, (colorInt & 0xFF_00_00_00L) == 0 ? (int) (colorInt & 0x00_FF_FF_FFL) | (SF.getColor(baseConfig) & 0xFF_00_00_00) : ((int)colorInt));
+                        //noinspection AssignmentToForLoopParameter
+                        i += offAmount;
+                        continue;
+                    }
+
+                } else {
+                    final int formatCode = TextFormatting.FORMAT_CHARS.indexOf(cNext);
+                    if (formatCode != -1) {
+                        switch (cNext) {
+                            case '0': case '1': case '2': case '3': case '4': case '5': case '6': case '7': case '8': case '9': case 'a': case 'b': case 'c': case 'd': case 'e': case 'f': {
+                                this.currentConfig = SF.setColor(this.currentConfig, Colors.allChatColors[MathHelper.clamp(formatCode, 0, 15)].value);
+                                break;
+                            }
+                            case 'k': {
+                                this.currentConfig = SF.setObfuscated(this.currentConfig);
+                                break;
+                            }
+                            case 'l': {
+                                this.currentConfig = SF.setBold(this.currentConfig);
+                                break;
+                            }
+                            case 'm': {
+                                this.currentConfig = SF.setStrikethrough(this.currentConfig);
+                                break;
+                            }
+                            case 'n': {
+                                this.currentConfig = SF.setUnderline(this.currentConfig);
+                                break;
+                            }
+                            case 'o': {
+                                this.currentConfig = SF.setItalic(this.currentConfig);
+                                break;
+                            }
+                            case 'r': {
+                                this.currentConfig = Integer.toUnsignedLong(SF.getColor(baseConfig));
+                                break;
+                            }
+                            case '+': {
+                                if (this.stackIndex == this.configStack.length - 1) {
+                                    break;
+                                }
+                                this.configStack[this.stackIndex] = this.currentConfig;
+                                this.stackIndex++;
+                                break;
+                            }
+                            case '-': {
+                                if (this.stackIndex == 0) {
+                                    break;
+                                }
+                                this.stackIndex--;
+                                this.currentConfig = this.configStack[this.stackIndex];
+                                break;
+                            }
+                        }
+                        //noinspection AssignmentToForLoopParameter
+                        i++;
+                        continue;
+                    }
+                }
+            }
+
+            final int tex = textureForChar(c);
+            if (this.currentTex != tex) {
+                this.currentTex = tex;
+                GL11.glBindTexture(GL11.GL_TEXTURE_2D, tex);
+            }
+
+            currX += renderCharInternal(tessellator, c, currX, currY, z, SF.getColor(this.currentConfig), shadow);
+        }
+
+        if (xPosBuffer != null) {
+            xPosBuffer[0] = currX;
+        }
+        if (yPosBuffer != null) {
+            yPosBuffer[0] = currY + fontHeight() + 1;
+        }
+        if (configBuffer != null) {
+            configBuffer[0] = this.currentConfig;
+        }
+    }
+
+    protected double renderCharInternal(@NotNull final Tessellator tessellator, final char c, final double x, final double y, final double z, final int color, final boolean shadow) {
+        final int rgb = color & 0xFFFFFF;
+        final int shadowRGB = (color & 0xFCFCFC) >> 2; // Divide RGB by 4
+        final int a = (color & 0xFF_00_00_00) != 0 ? (color >> 24) & 0xFF : 0xFF;
+        tessellator.startDrawingQuads();
+        double shift;
+        final int fontIndex = ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(c);
+        if (SF.isObfuscated(this.currentConfig) && c != ' ' && fontIndex > 0) {
+            shift = charWidth(c);
+            final char randomChar = getObfuscatedChar(c, this.random);
+
+            if (shadow) {
+                tessellator.setColorRGBA_I(shadowRGB, a);
+                renderChar(tessellator, randomChar, x + 1, y + 1, z, SF.isItalic(this.currentConfig));
+                if (SF.isBold(this.currentConfig)) renderChar(tessellator, randomChar, x + 2, y + 1, z, SF.isItalic(this.currentConfig));
+            }
+
+            tessellator.setColorRGBA_I(rgb, a);
+            renderChar(tessellator, randomChar, x, y, z, SF.isItalic(this.currentConfig));
+            if (SF.isBold(this.currentConfig)) {
+                renderChar(tessellator, randomChar, x + 1, y, z, SF.isItalic(this.currentConfig));
+                shift++;
+            }
+
+        } else {
+            if (shadow) {
+                tessellator.setColorRGBA_I(shadowRGB, a);
+                renderChar(tessellator, c, x + 1, y + 1, z, SF.isItalic(this.currentConfig));
+                if (SF.isBold(this.currentConfig)) renderChar(tessellator, c, x + 2, y + 1, z, SF.isItalic(this.currentConfig));
+            }
+
+            tessellator.setColorRGBA_I(rgb, a);
+            shift = renderChar(tessellator, c, x, y, z, SF.isItalic(this.currentConfig));
+            if (SF.isBold(this.currentConfig)) {
+                renderChar(tessellator, c, x + 1, y, z, SF.isItalic(this.currentConfig));
+                shift++;
+            }
+        }
+        tessellator.draw();
+
+        if (SF.isStrikethrough(this.currentConfig)) {
+            GL11.glDisable(GL11.GL_TEXTURE_2D);
+            tessellator.startDrawingQuads();
+            if (shadow) {
+                tessellator.setColorRGBA_I(shadowRGB, a);
+                tessellator.addVertex(x + 1,        y + 1 + fontHeight() / 2d,       0.0D);
+                tessellator.addVertex(x + 1 + shift,y + 1 + fontHeight() / 2d,       0.0D);
+                tessellator.addVertex(x + 1 + shift,y + 1 + fontHeight() / 2d - 1.0F,0.0D);
+                tessellator.addVertex(x + 1,        y + 1 + fontHeight() / 2d - 1.0F,0.0D);
+            }
+            tessellator.setColorRGBA_I(rgb, a);
+            tessellator.addVertex(x,        y + fontHeight() / 2d,       0.0D);
+            tessellator.addVertex(x + shift,y + fontHeight() / 2d,       0.0D);
+            tessellator.addVertex(x + shift,y + fontHeight() / 2d - 1.0F,0.0D);
+            tessellator.addVertex(x,        y + fontHeight() / 2d - 1.0F,0.0D);
+            tessellator.draw();
+            GL11.glEnable(GL11.GL_TEXTURE_2D);
+        }
+
+        if (SF.isUnderline(this.currentConfig)) {
+            GL11.glDisable(GL11.GL_TEXTURE_2D);
+            tessellator.startDrawingQuads();
+            if (shadow) {
+                tessellator.setColorRGBA_I(shadowRGB, a);
+                tessellator.addVertex(x,            y + 2 + fontHeight(),        0.0D);
+                tessellator.addVertex(x + 1 + shift,y + 2 + fontHeight(),        0.0D);
+                tessellator.addVertex(x + 1 + shift,y + 2 + fontHeight() - 1.0F, 0.0D);
+                tessellator.addVertex(x,            y + 2 + fontHeight() - 1.0F, 0.0D);
+            }
+            tessellator.setColorRGBA_I(rgb, a);
+            tessellator.addVertex(x - 1,    y + 1 + fontHeight(),        0.0D);
+            tessellator.addVertex(x + shift,y + 1 + fontHeight(),        0.0D);
+            tessellator.addVertex(x + shift,y + 1 + fontHeight() - 1.0F, 0.0D);
+            tessellator.addVertex(x - 1,    y + 1 + fontHeight() - 1.0F, 0.0D);
+            tessellator.draw();
+            GL11.glEnable(GL11.GL_TEXTURE_2D);
+        }
+        return shift;
+    }
+    @Override
+    public void renderDouble(@NotNull final Tessellator tessellator, final @NotNull CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        this.currentTex = -1;
+        this.currentConfig = baseConfig;
+        this.stackIndex = 0;
+        renderStringInternal(tessellator, chars, x, y, z, shadow, baseConfig, xPosBuffer, yPosBuffer, configBuffer);
+    }
+
+    @Override
+    public void render(@NotNull final Tessellator tessellator, final @NotNull CharSequence chars, final int x, final int y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        renderDouble(tessellator, chars, x, y, z, shadow, baseConfig, xPosBuffer, yPosBuffer, configBuffer);
+    }
+
+    @Override
+    public void renderCenteredDouble(@NotNull final Tessellator tessellator, final @NotNull CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        renderDouble(tessellator, chars, x - stringWidthDouble(chars)/2d, y, z, shadow, baseConfig, xPosBuffer, yPosBuffer, configBuffer);
+    }
+
+    @Override
+    public void renderCentered(@NotNull final Tessellator tessellator, final @NotNull CharSequence chars, final int x, final int y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        render(tessellator, chars, x - stringWidth(chars)/2, y, z, shadow, baseConfig, xPosBuffer, yPosBuffer, configBuffer);
+    }
+
+    @Override
+    public void renderWidthConstrainedDouble(@NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double maxWidth, @NotNull final Alignment alignment, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        this.currentTex = -1;
+        this.currentConfig = baseConfig;
+        this.stackIndex = 0;
+
+        final List<String> lines = splitCharsIntoLines(chars, maxWidth, this.localStringList);
+
+        double currY = y;
+        switch (alignment) {
+            case LEFT: {
+                for (int i = 0; i < lines.size(); i++) {
+                    final String line = lines.get(i);
+                    renderStringInternal(tessellator, line, x, currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
+                    currY += fontHeight() + 1;
+                }
+                break;
+            }
+            case RIGHT: {
+                for (int i = 0; i < lines.size(); i++) {
+                    final String line = lines.get(i);
+                    renderStringInternal(tessellator, line, x + (maxWidth - stringWidthDouble(line)), currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
+                    currY += fontHeight() + 1;
+                }
+                break;
+            }
+            case CENTERED: {
+                for (int i = 0; i < lines.size(); i++) {
+                    final String line = lines.get(i);
+                    renderStringInternal(tessellator, line, x + (maxWidth - stringWidthDouble(line))/2, currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
+                    currY += fontHeight() + 1;
+                }
+                break;
+            }
+        }
+
+        if (xPosBuffer != null) {
+            xPosBuffer[0] = x + maxWidth;
+        }
+        if (yPosBuffer != null) {
+            yPosBuffer[0] = currY;
+        }
+        if (configBuffer != null) {
+            configBuffer[0] = this.localConfigBuffer[0];
+        }
+    }
+
+    @Override
+    public void renderWidthConstrained(@NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final int x, final int y, final double z, final boolean shadow, final long baseConfig, final int maxWidth, @NotNull final Alignment alignment, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        this.currentTex = -1;
+        this.currentConfig = baseConfig;
+        this.stackIndex = 0;
+
+        final List<String> lines = splitCharsIntoLines(chars, maxWidth, this.localStringList);
+
+        int currY = y;
+        switch (alignment) {
+            case LEFT: {
+                for (int i = 0; i < lines.size(); i++) {
+                    final String line = lines.get(i);
+                    renderStringInternal(tessellator, line, x, currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
+                    currY += fontHeight() + 1;
+                }
+                break;
+            }
+            case RIGHT: {
+                for (int i = 0; i < lines.size(); i++) {
+                    final String line = lines.get(i);
+                    renderStringInternal(tessellator, line, x + (maxWidth - stringWidth(line)), currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
+                    currY += fontHeight() + 1;
+                }
+                break;
+            }
+            case CENTERED: {
+                for (int i = 0; i < lines.size(); i++) {
+                    final String line = lines.get(i);
+                    renderStringInternal(tessellator, line, (int)(x + (maxWidth - stringWidth(line))/2), currY, z, shadow, baseConfig, this.localXPosBuffer, this.localYPosBuffer, this.localConfigBuffer);
+                    currY += fontHeight() + 1;
+                }
+                break;
+            }
+        }
+
+        if (xPosBuffer != null) {
+            xPosBuffer[0] = x + maxWidth;
+        }
+        if (yPosBuffer != null) {
+            yPosBuffer[0] = currY;
+        }
+        if (configBuffer != null) {
+            configBuffer[0] = this.localConfigBuffer[0];
+        }
+    }
+
+    @Override
+    public void renderConstrainedDouble(@NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double maxWidth, final double maxHeight, @NotNull final Alignment alignment, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        this.currentTex = -1;
+        this.currentConfig = baseConfig;
+        this.stackIndex = 0;
+
+        final List<String> lines = splitCharsIntoLines(chars, maxWidth, this.localStringList);
+
+        double currY = y;
+        this.localConfigBuffer[0] = baseConfig;
+        switch (alignment) {
+            case LEFT: {
+                for (int i = 0; i < lines.size(); i++) {
+                    final String line = lines.get(i);
+                    renderStringInternal(tessellator, line, x, currY, z, shadow, baseConfig, null, null, this.localConfigBuffer);
+                    currY += fontHeight() + 1;
+                    if ((currY - y) > maxHeight) break;
+                }
+                break;
+            }
+            case RIGHT: {
+                for (int i = 0; i < lines.size(); i++) {
+                    final String line = lines.get(i);
+                    renderStringInternal(tessellator, line, x + (maxWidth - stringWidthDouble(line)), currY, z, shadow, baseConfig, null, null, this.localConfigBuffer);
+                    currY += fontHeight() + 1;
+                    if ((currY - y) > maxHeight) break;
+                }
+                break;
+            }
+            case CENTERED: {
+                for (int i = 0; i < lines.size(); i++) {
+                    final String line = lines.get(i);
+                    renderCenteredDouble(tessellator, line, x + maxWidth/2, currY, z, shadow, baseConfig, null, null, this.localConfigBuffer);
+                    currY += fontHeight() + 1;
+                    if ((currY - y) > maxHeight) break;
+                }
+                break;
+            }
+        }
+
+        if (xPosBuffer != null) {
+            xPosBuffer[0] = x + maxWidth;
+        }
+        if (yPosBuffer != null) {
+            yPosBuffer[0] = currY;
+        }
+        if (configBuffer != null) {
+            configBuffer[0] = this.localConfigBuffer[0];
+        }
+    }
+
+    @Override
+    public void renderConstrained(@NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final int x, final int y, final double z, final boolean shadow, final long baseConfig, final int maxWidth, final int maxHeight, @NotNull final Alignment alignment, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        renderConstrainedDouble(tessellator, chars, x, y, z, shadow, baseConfig, maxWidth, maxHeight, alignment, xPosBuffer, yPosBuffer, configBuffer);
+    }
+
+    private static final StringBuilder splitLineIntoConstrainedLine_lineBuilder = new StringBuilder();
+    private static final StringBuilder splitLineIntoConstrainedLine_wordBuilder = new StringBuilder();
+    protected void splitLineIntoConstrainedLine(final @NotNull CharSequence line, final double maxWidth, final @NotNull List<String> output) {
+        final double dashWidth = charWidthDouble('-');
+        final double spaceWidth = charWidthDouble(' ');
+
+        double currLineWidth = 0;
+        double currWordWidth = 0;
+
+        splitLineIntoConstrainedLine_lineBuilder.setLength(0);
+        splitLineIntoConstrainedLine_wordBuilder.setLength(0);
+
+        final int length = line.length();
+        for (int i = 0; i < length; i++) {
+            final char c = line.charAt(i);
+
+            if (c == '\n') {
+                splitLineIntoConstrainedLine_lineBuilder.append(splitLineIntoConstrainedLine_wordBuilder);
+                splitLineIntoConstrainedLine_wordBuilder.setLength(0);
+                currWordWidth = 0;
+
+                output.add(splitLineIntoConstrainedLine_lineBuilder.toString());
+                splitLineIntoConstrainedLine_lineBuilder.setLength(0);
+                currLineWidth = 0;
+                continue;
+            }
+
+            if (c == '\t') {
+                splitLineIntoConstrainedLine_wordBuilder.append("   ");
+                currWordWidth += spaceWidth * 3;
+                continue;
+            }
+
+            if (c == '§' && i + 1 < length) { // Skip formatting
+                final char cN = line.charAt(i + 1);
+                if (cN == '<') {
+                    int offAmount = 1;
+                    int j = i + 2; // first char after '<'
+                    boolean ended = false;
+                    while (j < length) {
+                        offAmount++;
+                        if (line.charAt(j) == '>'){
+                            ended = true;
+                            break;
+                        }
+                        j++;
+                    }
+
+                    if (ended){
+                        // Add all entire rgb format symbols to word and skip index to next char after
+                        splitLineIntoConstrainedLine_wordBuilder.append(line, i, i + offAmount + 1);
+                        //noinspection AssignmentToForLoopParameter
+                        i += offAmount;
+                        continue;
+                    }
+                } else if (TextFormatting.FORMAT_CHARS.indexOf(cN) != -1) {
+                    // Add format symbols then skip to index after
+                    splitLineIntoConstrainedLine_wordBuilder.append(line, i, i + 2);
+                    //noinspection AssignmentToForLoopParameter
+                    i++;
+                    continue;
+                }
+            }
+
+            final double charWidth = charWidthDouble(c);
+            if (currWordWidth + charWidth + dashWidth > maxWidth) {
+                splitLineIntoConstrainedLine_wordBuilder.append('-');
+                splitLineIntoConstrainedLine_lineBuilder.append(splitLineIntoConstrainedLine_wordBuilder);
+
+                splitLineIntoConstrainedLine_wordBuilder.setLength(0);
+                splitLineIntoConstrainedLine_wordBuilder.append(c);
+                currWordWidth = charWidth;
+
+                output.add(splitLineIntoConstrainedLine_lineBuilder.toString().trim());
+                splitLineIntoConstrainedLine_lineBuilder.setLength(0);
+                currLineWidth = 0;
+                continue;
+            }
+
+            if (currLineWidth + currWordWidth + charWidth > maxWidth) { //
+                if (c == ' ') {
+                    splitLineIntoConstrainedLine_lineBuilder.append(splitLineIntoConstrainedLine_wordBuilder);
+                } else {
+                    splitLineIntoConstrainedLine_wordBuilder.append(c);
+                    currWordWidth += charWidth;
+                }
+                output.add(splitLineIntoConstrainedLine_lineBuilder.toString().trim());
+                splitLineIntoConstrainedLine_lineBuilder.setLength(0);
+                currLineWidth = 0;
+                continue;
+            }
+
+            if (c == ' ') {
+                splitLineIntoConstrainedLine_lineBuilder.append(splitLineIntoConstrainedLine_wordBuilder).append(' ');
+                currLineWidth += currWordWidth + spaceWidth;
+
+                splitLineIntoConstrainedLine_wordBuilder.setLength(0);
+                currWordWidth = 0;
+                continue;
+            }
+
+            splitLineIntoConstrainedLine_wordBuilder.append(c);
+            currWordWidth += charWidth;
+        }
+        splitLineIntoConstrainedLine_lineBuilder.append(splitLineIntoConstrainedLine_wordBuilder);
+        final String remainder = splitLineIntoConstrainedLine_lineBuilder.toString().trim();
+        if (!remainder.isEmpty()) {
+            output.add(remainder);
+        }
+    }
+    @Override
+    public @NotNull List<String> splitCharsIntoLines(@NotNull final CharSequence chars, final double maxWidth, @Nullable final List<String> output) {
+        final @NotNull List<String> o = output == null ? new ArrayList<>() : output;
+        o.clear();
+        splitLineIntoConstrainedLine(chars, maxWidth, o);
+        return o;
+    }
+
+    @Override
+    public @NotNull List<String> splitLinesIntoConstrainedLines(@NotNull final List<String> lines, final double maxWidth, @Nullable final List<String> output) {
+        final @NotNull List<String> o = output == null ? new ArrayList<>() : output;
+        o.clear();
+        for (int i = 0; i < lines.size(); i++) {
+            splitLineIntoConstrainedLine(lines.get(i), maxWidth, o);
+        }
+        return o;
+    }
+
+    @Override
+    public double heightOfConstrainedChars(@NotNull final CharSequence chars, final double maxWidth) {
+        splitCharsIntoLines(chars, maxWidth, this.localStringList);
+        return this.localStringList.size() * (fontHeight() + 1);
+    }
+
+    @Override
+    public double heightOfLines(@NotNull final List<@NotNull String> lines, final double maxWidth) {
+        splitLinesIntoConstrainedLines(lines, maxWidth, this.localStringList);
+        return this.localStringList.size() * (fontHeight() + 1);
+    }
+
+    @Override
+    public void init(@NotNull final TexturePackList packList) {
+        this.font.init(packList);
+        this.fallbackFont.init(packList);
+    }
+
+    @Override
+    public int textureForChar(final char c) {
+        return getFont(c).textureForChar(c);
+    }
+
+    @Override
+    public char getObfuscatedChar(final char c, final Random random) {
+        return getFont(c).getObfuscatedChar(c, random);
+    }
+
+    @Override
+    public boolean canRenderChar(final char c) {
+        return this.font.canRenderChar(c) || this.fallbackFont.canRenderChar(c);
+    }
+
+    @Override
+    public double charWidthDouble(final char c) {
+        return getFont(c).charWidthDouble(c);
+    }
+
+    @Override
+    public double stringWidthDouble(final CharSequence chars) {
+        double width = 0;
+        final int length = chars.length();
+        for (int i = 0; i < length; i++) {
+            final char c = chars.charAt(i);
+
+            if (c == '§' && i + 1 < length) { // Skip formatting
+                final char cN = chars.charAt(i + 1);
+                if (cN == '<') {
+                    int offAmount = 1;
+                    int j = i + 2; // first char after '<'
+                    boolean ended = false;
+                    while (j < length) {
+                        offAmount++;
+                        if (chars.charAt(j) == '>'){
+                            ended = true;
+                            break;
+                        }
+                        j++;
+                    }
+
+                    if (ended){
+                        //noinspection AssignmentToForLoopParameter
+                        i += offAmount;
+                        continue;
+                    }
+                } else if (TextFormatting.FORMAT_CHARS.indexOf(cN) != -1) {
+                    //noinspection AssignmentToForLoopParameter
+                    i++;
+                    continue;
+                }
+            }
+
+            width += charWidthDouble(c);
+        }
+        return width;
+    }
+
+    @Override
+    public int fontHeight() {
+        return getFont().fontHeight();
+    }
+
+    @Override
+    public double renderChar(final Tessellator tessellator, final char c, final double x, final double y, final double z, final boolean italics) {
+        return getFont(c).renderChar(tessellator, c, x, y, z, italics);
+    }
+
+    protected @NotNull Font getFont(final char c) {
+        if (Minecraft.getMinecraft().gameSettings.forceUnicodeFont.value || !this.font.canRenderChar(c)) return this.fallbackFont;
+        return this.font;
+    }
+
+    protected @NotNull Font getFont() {
+        if (Minecraft.getMinecraft().gameSettings.forceUnicodeFont.value) return this.fallbackFont;
+        return this.font;
+    }
+
+    public static int decodeHexToInt(final @NotNull CharSequence hexSequence) throws NumberFormatException {
+        int value = 0;
+        final int length = hexSequence.length();
+        for (int i = 0; i < length; i++) {
+            final char c = hexSequence.charAt(length - i - 1);
+            switch (c) {
+                case '0': { break; }
+                case '1': { value |= 0x1 << (4 * i); break; }
+                case '2': { value |= 0x2 << (4 * i); break; }
+                case '3': { value |= 0x3 << (4 * i); break; }
+                case '4': { value |= 0x4 << (4 * i); break; }
+                case '5': { value |= 0x5 << (4 * i); break; }
+                case '6': { value |= 0x6 << (4 * i); break; }
+                case '7': { value |= 0x7 << (4 * i); break; }
+                case '8': { value |= 0x8 << (4 * i); break; }
+                case '9': { value |= 0x9 << (4 * i); break; }
+                case 'A': case 'a': { value |= 0xA << (4 * i); break; }
+                case 'B': case 'b': { value |= 0xB << (4 * i); break; }
+                case 'C': case 'c': { value |= 0xC << (4 * i); break; }
+                case 'D': case 'd': { value |= 0xD << (4 * i); break; }
+                case 'E': case 'e': { value |= 0xE << (4 * i); break; }
+                case 'F': case 'f': { value |= 0xF << (4 * i); break; }
+                default:
+                    throw new NumberFormatException("Illegal non hex char '" + c + "'");
+            }
+        }
+        return value;
+    }
+
+    public static long decodeHexToLong(final @NotNull CharSequence hexSequence) throws NumberFormatException {
+        long value = 0;
+        final int length = hexSequence.length();
+        for (int i = 0; i < length; i++) {
+            final char c = hexSequence.charAt(length - i - 1);
+            switch (c) {
+                case '0': { break; }
+                case '1': { value |= 0x1L << (4 * i); break; }
+                case '2': { value |= 0x2L << (4 * i); break; }
+                case '3': { value |= 0x3L << (4 * i); break; }
+                case '4': { value |= 0x4L << (4 * i); break; }
+                case '5': { value |= 0x5L << (4 * i); break; }
+                case '6': { value |= 0x6L << (4 * i); break; }
+                case '7': { value |= 0x7L << (4 * i); break; }
+                case '8': { value |= 0x8L << (4 * i); break; }
+                case '9': { value |= 0x9L << (4 * i); break; }
+                case 'A': case 'a': { value |= 0xAL << (4 * i); break; }
+                case 'B': case 'b': { value |= 0xBL << (4 * i); break; }
+                case 'C': case 'c': { value |= 0xCL << (4 * i); break; }
+                case 'D': case 'd': { value |= 0xDL << (4 * i); break; }
+                case 'E': case 'e': { value |= 0xEL << (4 * i); break; }
+                case 'F': case 'f': { value |= 0xFL << (4 * i); break; }
+                default:
+                    throw new NumberFormatException("Illegal non hex char '" + c + "'");
+            }
+        }
+        return value;
+    }
+}
